var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { TransitionGroup, CSSTransition } from 'react-transition-group';
import { Switch, withRouter } from 'react-router';
import PropTypes from 'prop-types';

var lastLocaton = { isPush: true };
var REACT_HISTORIES_KEY = 'REACT_HISTORIES_KEY';
var histories = (sessionStorage.getItem(REACT_HISTORIES_KEY) || '').split(',').filter(Boolean);
var isHistoryPush = function isHistoryPush(location, update) {
    if (update && location.key !== lastLocaton.key) {
        var index = histories.lastIndexOf(location.key);

        if (index > -1) {
            histories.splice(index + 1);
        } else {
            histories.push(location.key);
        }

        sessionStorage.setItem(REACT_HISTORIES_KEY, histories.join(','));

        lastLocaton = {
            isPush: index < 0,
            key: location.key
        };
    }

    return lastLocaton.isPush;
};

/**
 * @desc 路由动画组件
 * @author qiqiboy
 *
 *  需要动画样式文件配合，所以如果使用默认的动画效果，则需要一并将项目中的animated.css导入项目
 *  import AnimatedRouter from 'react-animated-router';
 *  import 'react-animated-router/animate.css';
 */

var AnimatedRouter = withRouter(_class = (_temp = _class2 = function (_Component) {
    _inherits(AnimatedRouter, _Component);

    function AnimatedRouter() {
        _classCallCheck(this, AnimatedRouter);

        return _possibleConstructorReturn(this, (AnimatedRouter.__proto__ || Object.getPrototypeOf(AnimatedRouter)).apply(this, arguments));
    }

    _createClass(AnimatedRouter, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                className = _props.className,
                location = _props.location,
                children = _props.children,
                timeout = _props.timeout,
                prefix = _props.prefix;


            return React.createElement(
                TransitionGroup,
                {
                    className: 'animated-router-container' + (className ? ' ' + className : ''),
                    childFactory: function childFactory(child) {
                        var classNames = prefix + '-' + (isHistoryPush(location, child.props.in) ? 'forward' : 'backward');

                        return React.cloneElement(child, {
                            classNames: classNames
                        });
                    } },
                React.createElement(
                    CSSTransition,
                    {
                        key: this.props.transitionKey || location.pathname,
                        addEndListener: function addEndListener(node, done) {
                            node.addEventListener('transitionend', function (e) {
                                //确保动画来自于目标节点
                                if (e.target === node) {
                                    done();
                                }
                            }, false);
                        },
                        timeout: timeout },
                    React.createElement(
                        Switch,
                        { location: location },
                        children
                    )
                )
            );
        }
    }]);

    return AnimatedRouter;
}(Component), _class2.propTypes = {
    className: PropTypes.string,
    transitionKey: PropTypes.any,
    timeout: PropTypes.number,
    prefix: PropTypes.string
}, _class2.defaultProps = {
    prefix: 'animated-router'
}, _temp)) || _class;

export default AnimatedRouter;